/*

./test_srv -- -ORBInitRef NameService=corbaloc:iiop:127.0.0.1:2809/NameService

 */

#include <rtt/os/main.h>

#include <rtt/TaskContext.hpp>
#include <rtt/Property.hpp>
#include <rtt/Port.hpp>
#include <rtt/Operation.hpp>
#include <rtt/Activity.hpp>

#include <rtt/transports/corba/TaskContextServer.hpp>

using namespace RTT;
using namespace RTT::corba;

class Foo : public RTT::TaskContext
{
public:

  Foo(std::string name) : 
    RTT::TaskContext(name, PreOperational)
  {
    // operations
    this->addOperation("getDiskUsage", &Foo::getDiskUsage, this , RTT::ClientThread).doc("Get disk usage in %.");
  }

  double getDiskUsage(void) const
  {
    static double du = 0;
    return du++;
  }
};

int ORO_main(int argc, char** argv)
{
  Foo foo("Foo");
  foo.setActivity( new RTT::Activity( 5, 4 ));

  foo.configure();
  foo.start();


  // Setup Corba and Export:
  TaskContextServer::InitOrb(argc, argv);

  TaskContextServer::Create( &foo );

  // Wait for requests:
  TaskContextServer::RunOrb();
      
  // Cleanup Corba:
  TaskContextServer::DestroyOrb();

  return 0;
} 
